-- Import necessary modules
require "import"
--import "com.androlua.*"
import "android.app.*"
import "android.graphics.*"
import "android.widget.*"
import "android.view.*"
import "android.view.GestureDetector"
import "android.view.MotionEvent"
import "android.content.*"
import "android.media.MediaPlayer"
import "android.net.Uri"
import "java.io.File"
import "java.util.ArrayList"
import "android.app.AlertDialog"
import "android.content.DialogInterface"
import "android.widget.Toast"
import "android.content.Intent"
import "android.text.*"
import "android.view.Window"
import "android.view.WindowManager.*"
import "android.os.*"

activity.setTitle("Video Player by Jieshuo for arabs")
activity.setTheme(android.R.style.Theme_Holo_Light)

local videoLayoutParams = LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, 0, 1) 
local videoView = VideoView(activity)
videoView.setLayoutParams(videoLayoutParams)

-- Define the folder containing your videos (replace with your folder path)
local folderPath = "/storage/emulated/0/"

-- Create a playlist to store video URIs
local playlist = ArrayList()

-- Function to recursively explore files in a folder
local function exploreFolder(folder)
    local files = folder.listFiles()
    if files then
        for i = 0, #files - 1 do
            local file = files[i]
            if file.isFile() then
                local fileName = file.getName()
                if fileName:match("%.mp4$") then
                    playlist.add(Uri.fromFile(file))
                end
            elseif file.isDirectory() then
                exploreFolder(file)
            end
        end
    end
end

-- Initialize the current index
local currentIndex = 0

-- Create MediaController for video playback controls
--local mediaController = MediaController(activity)
--mediaController.setAnchorView(videoView)
--videoView.setMediaController(mediaController)

-- Create Play/Pause Button
local playPauseButton = Button(activity)
playPauseButton.setText("Play")
local isPlaying = false

-- Create Next Button
local nextButton = Button(activity)
nextButton.setText("Next")

-- Create Previous Button
local prevButton = Button(activity)
prevButton.setText("Previous")

-- Create a SeekBar for seeking
local seekBar = SeekBar(activity)
seekBar.setLayoutParams(LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT))
seekBar.setMax(100) 
-- Max value for the seek bar

-- Create a Button to show all files
local showAllButton = Button(activity)
showAllButton.setText("Show All Files")

-- Create a Delete Button
local deleteButton = Button(activity)
deleteButton.setText("Delete")

-- Create a rename Button
local renameButton = Button(activity)
renameButton.setText("rename")

-- Function to loop to the next video or back to the first when reaching the last
local function nextOrLoop()
    currentIndex = (currentIndex + 1) % playlist.size()
    videoView.setVideoURI(playlist.get(currentIndex))
    videoView.start()
    playPauseButton.setText("Pause")
    isPlaying = true
end

-- Function to play the first video in the playlist
local function playFirstVideo()
    if not isPlaying and playlist.size() > 0 then
        currentIndex = 0
        videoView.setVideoURI(playlist.get(currentIndex))
        videoView.start()
        playPauseButton.setText("Pause")
        isPlaying = true

        -- Keep the screen on while playing
        activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON)
        
        -- Set up a listener for video completion
        videoView.setOnCompletionListener(MediaPlayer.OnCompletionListener {
            onCompletion = function(mp)
                -- Add a short delay (e.g., 500 milliseconds) and then restart the current video
                Handler().postDelayed(function()
                    videoView.seekTo(0)  -- Rewind to the beginning
                    videoView.start()    -- Start playing again
                end, 50) -- 500 milliseconds (0.5 seconds) delay
            end
        })
    end
end

-- Function to loop to the next video or back to the first when reaching the last
local function nextOrLoop()
    currentIndex = (currentIndex + 1) % playlist.size()
    videoView.setVideoURI(playlist.get(currentIndex))
    videoView.start()
    playPauseButton.setText("Pause")
    isPlaying = true
end

-- Function to loop to the previous video or back to the last when reaching the first
local function prevOrLoop()
    currentIndex = (currentIndex - 1 + playlist.size()) % playlist.size()
    videoView.setVideoURI(playlist.get(currentIndex))
    videoView.start()
    playPauseButton.setText("Pause")
    isPlaying = true
end

local function updateSeekBar()
    local currentPosition = videoView.getCurrentPosition()
    local totalDuration = videoView.getDuration()
    
    -- Calculate the percentage
    local percentage = (currentPosition * 100) / totalDuration
    
    -- Update the seek bar progress
    seekBar.setProgress(percentage)
    
    -- Repeat this function after a short delay (e.g., 100 milliseconds)
    Handler().postDelayed(updateSeekBar, 100)
end

-- Call the function to update the seek bar progress
updateSeekBar()

-- Function to handle seek bar changes
local function onSeekBarChange(seekBar, progress, fromUser)
    if fromUser then
        local totalDuration = videoView.getDuration()
        local newPosition = (progress * totalDuration) / 100
        videoView.seekTo(newPosition)
    end
end

-- Create a TextView for displaying current track info
local trackInfo = TextView(activity)
trackInfo.setTextSize(18)
trackInfo.setTextColor(0xFFFFFFFF)
trackInfo.setGravity(Gravity.CENTER) -- Center the text horizontally

-- ... (Other code)

-- Function to update track info when the video changes
local function updateTrackInfo()
    if not playlist.isEmpty() then
        local videoUri = playlist.get(currentIndex)
        local videoFile = File(videoUri.getPath())
        local videoName = videoFile.getName()
        trackInfo.setText("Track: " .. videoName)
    else
        trackInfo.setText("No videos in playlist")
    end
end

-- ... (Other code)

-- Function to play the first video in the playlist
local function playFirstVideo()
    if not isPlaying and playlist.size() > 0 then
        currentIndex = 0
        videoView.setVideoURI(playlist.get(currentIndex))
        videoView.start()
        playPauseButton.setText("Pause")
        isPlaying = true

        -- Keep the screen on while playing
        activity.getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON)
        
        -- Set up a listener for video completion
        videoView.setOnCompletionListener(MediaPlayer.OnCompletionListener {
            onCompletion = function(mp)
                -- Add a short delay (e.g., 500 milliseconds) and then restart the current video
                Handler().postDelayed(function()
                    videoView.seekTo(0)  -- Rewind to the beginning
                    videoView.start()    -- Start playing again
                end, 50) -- 500 milliseconds (0.5 seconds) delay
            end
        })
        
        -- Update the track info
        updateTrackInfo()
    end
end

-- Function to delete the currently playing file
local function deleteCurrentFile()
    if currentIndex >= 0 and currentIndex < playlist.size() then
        local fileToDelete = File(playlist.get(currentIndex).getPath())
        if fileToDelete.exists() then
            fileToDelete.delete()
            playlist.remove(currentIndex)
        end
        if currentIndex >= playlist.size() then
            currentIndex = playlist.size() - 1
        end
        if playlist.size() > 0 then
            videoView.setVideoURI(playlist.get(currentIndex))
            videoView.start()
            playPauseButton.setText("Pause")
            isPlaying = true
        else
            -- No more videos in the playlist, clear the videoView
            videoView.stopPlayback()
            playPauseButton.setText("Play")
            isPlaying = false
        end
    end
end

playPauseButton.setOnClickListener(View.OnClickListener {
    onClick = function(v)
        if isPlaying then
            videoView.pause()
            playPauseButton.setText("Play")
        else
            videoView.start()
            playPauseButton.setText("Pause")
        end
        isPlaying = not isPlaying
    end
})

nextButton.setOnClickListener(View.OnClickListener {
    onClick = function(v)
        nextOrLoop()
    end
})

prevButton.setOnClickListener(View.OnClickListener {
    onClick = function(v)
        prevOrLoop()
    end
})

-- Set up the seek bar listener
seekBar.setOnSeekBarChangeListener(SeekBar.OnSeekBarChangeListener {
    onProgressChanged = function(seekBar, progress, fromUser)
        onSeekBarChange(seekBar, progress, fromUser)
    end,
    onStartTrackingTouch = function(seekBar)
        -- Handle when the user starts touching the seek bar if needed
    end,
    onStopTrackingTouch = function(seekBar)
        -- Handle when the user stops touching the seek bar if needed
    end
})

deleteButton.setOnClickListener(View.OnClickListener {
    onClick = function(v)
        deleteCurrentFile()
    end
})

-- Function to show a confirmation dialog before deleting the currently playing file
local function confirmDeleteCurrentFile()
    local builder = AlertDialog.Builder(activity)
    builder.setTitle("Confirm Delete")
    builder.setMessage("Are you sure you want to delete this video?")
    
    builder.setPositiveButton("Yes", DialogInterface.OnClickListener {
        onClick = function(dialog, which)
            deleteCurrentFile() -- Call the delete function if "Yes" is clicked
        end
    })
    
    builder.setNegativeButton("No", DialogInterface.OnClickListener {
        onClick = function(dialog, which)
            dialog.dismiss() -- Dismiss the dialog if "No" is clicked
        end
    })
    
    local dialog = builder.create()
    dialog.show()
end
deleteButton.setOnClickListener(View.OnClickListener {
    onClick = function(v)
        confirmDeleteCurrentFile() -- Show the confirmation dialog
    end
})

-- Call the function to explore the folder and add videos to the playlist
local folder = File(folderPath)
exploreFolder(folder)

local function renameCurrentFile()
    if (currentIndex >= 0) and (currentIndex < #playlist) then
        -- Check if the playlist is not nil and has the isEmpty method
        if playlist and not playlist.isEmpty() then
            -- Get the current video's URI and file
            local currentVideoUri = playlist.get(currentIndex)
            local currentVideoFile = File(currentVideoUri.getPath())
            
            local currentVideoName = currentVideoFile.getName()
            
            -- Create an AlertDialog to get the new name from the user
            local renameDialog = AlertDialog.Builder(activity)
            renameDialog.setTitle("Rename Video")
            
            -- Create an EditText for user input
            local input = EditText(activity)
            input.setInputType(InputType.TYPE_CLASS_TEXT)
            input.setText(currentVideoName) -- Set the current name as the initial text
            
            renameDialog.setView(input)
            
            renameDialog.setPositiveButton("Rename", DialogInterface.OnClickListener {
                onClick = function(dialog, which)
                    local newName = input.getText().toString()
                    
                    if newName then
                        -- Get the parent directory of the current file
                        local parentDirectory = currentVideoFile.getParentFile()
                        
                        -- Create a new file with the renamed path
                        local newFile = File(parentDirectory, newName)
                        
                        -- Check if the new name already exists
                        if newFile.exists() then
                            Toast.makeText(activity, "A file with this name already exists.", Toast.LENGTH_SHORT).show()
                        else
                            -- Rename the file
                            if currentVideoFile.renameTo(newFile) then
                                Toast.makeText(activity, "File renamed successfully.", Toast.LENGTH_SHORT).show()
                                
                                -- Update the playlist with the new URI
                                playlist.set(currentIndex, Uri.fromFile(newFile))
                                
                                -- Update the track info TextView
                                trackInfo.setText("Track: " .. newName)
                            else
                                Toast.makeText(activity, "Rename failed.", Toast.LENGTH_SHORT).show()
                            end
                        end
                    else
                        Toast.makeText(activity, "New name cannot be empty.", Toast.LENGTH_SHORT).show()
                    end
                end
            })
            
            renameDialog.setNegativeButton("Cancel", DialogInterface.OnClickListener {
                onClick = function(dialog, which)
                    dialog.dismiss() -- Dismiss the dialog if "Cancel" is clicked
                end
            })
            
            renameDialog.show()
        else
            Toast.makeText(activity, "Playlist is empty.", Toast.LENGTH_SHORT).show()
        end
    else
        Toast.makeText(activity, "Invalid playlist index.", Toast.LENGTH_SHORT).show()
    end
end

-- Set the renameCurrentFile function as the OnClickListener for the "Rename" button
renameButton.setOnClickListener(View.OnClickListener {
    onClick = function(v)
        renameCurrentFile() -- Call the rename function
renameCurrentFile()
    end
})

-- Function to share the currently playing video file
local function shareCurrentFile()
    if currentIndex >= 0 and currentIndex < #playlist then
        local fileToShare = File(playlist.get(currentIndex).getPath())
        if fileToShare.exists() then
local uri = activity.getUriForFile((fileToShare))
            
            -- Create an Intent to share the file
            local intent = Intent()
            intent.setAction(Intent.ACTION_SEND)
            intent.setType("video/*")
            intent.putExtra(Intent.EXTRA_STREAM, uri)
            intent.addFlags(Intent.FLAG_GRANT_READ_URI_PERMISSION)
            
            activity.startActivity(Intent.createChooser(intent, "Share Video"))
        end
    end
end
-- Add the Share Button to the controlLayout
local  shareButton= Button(activity)
shareButton.setText("share")
shareButton.setOnClickListener(function (v)
shareCurrentFile()
end)

fileListView= ListView(activity)
-- Function to show all files in the playlist
local function showAllFiles()
    local fileList = ArrayList({})
    for i = 0, playlist.size() - 1 do
        local videoUri = playlist.get(i)
        local videoFile = File(videoUri.getPath())
        local videoName = videoFile.getName()
        fileList.add(videoName)
    end
local fileListArray = {}
    for i = 0, fileList.size() - 1 do
        fileListArray[i + 1] = fileList.get(i)
    end
-- Function to play a video by name
local function playVideoByName(videoName)
    for i = 0, playlist.size() - 1 do
        local videoUri = playlist.get(i)
        local videoFile = File(videoUri.getPath())
        local fileName = videoFile.getName()
        if fileName == videoName then
            videoView.setVideoURI(videoUri)
            videoView.start()
            playPauseButton.setText("Pause")
            isPlaying = true
            return
        end
    end
end
local builder = AlertDialog.Builder(activity)
    builder.setTitle("All Files")
local adapter = ArrayAdapter(activity, android.R.layout.simple_list_item_1, fileListArray)
    builder.setAdapter(adapter, DialogInterface.OnClickListener {
        onClick = function(dialog, which)
            dialog.dismiss()
            local selectedVideoName = fileListArray[which + 1] -- Adjust for 0-based indexing
            playVideoByName(selectedVideoName)
        end
    })
builder.setPositiveButton("OK", DialogInterface.OnClickListener {
        onClick = function(dialog, which)
            dialog.dismiss()
        end
    })
local dialog = builder.create()
    dialog.show()
end
showAllButton.setOnClickListener(View.OnClickListener {
    onClick = function(v)
        showAllFiles()
    end
})

-- Create a Finish Task Button
local finishTaskButton = Button(activity)
finishTaskButton.setText("Finish Task")

-- Set an OnClickListener for the Finish Task Button
finishTaskButton.setOnClickListener(View.OnClickListener {
    onClick = function(v)
        -- Add code here to handle finishing the task
        -- You can update your app's logic to mark a task as completed
        -- For example, you might update a task status in a database or list
        -- You can also update the UI to visually indicate that the task is completed

function finishTask()
    -- Add your task completion logic here
   
activity.finish()
 print("Task finished!")
end

-- Call the function to finish the task
finishTask() end
})

-- Function to forward the video
local function forwardVideo()
    if isPlaying then
        local currentPosition = videoView.getCurrentPosition()
        local totalDuration = videoView.getDuration()
        
        -- Calculate the new position by adding some offset (e.g., 10 seconds)
        local newPosition = currentPosition + 10000  -- Forward by 10 seconds (adjust as needed)
        
        -- Ensure newPosition does not exceed the video's total duration
        newPosition = math.min(newPosition, totalDuration)
        
        videoView.seekTo(newPosition)
    end
end

-- Function to rewind the video
local function rewindVideo()
    if isPlaying then
        local currentPosition = videoView.getCurrentPosition()
        
        -- Calculate the new position by subtracting some offset (e.g., 10 seconds)
        local newPosition = currentPosition - 10000  -- Rewind by 10 seconds (adjust as needed)
        
        -- Ensure newPosition is not negative
        newPosition = math.max(newPosition, 0)
        
        videoView.seekTo(newPosition)
    end
end

local isTwoFingerTap = false
-- Create a GestureDetector to detect gestures
local gestureDetector = GestureDetector(activity, {
    onDown = function(e)
        isTwoFingerTap = false
    end,
onSingleTapConfirmed = function(e)
        -- Handle single tap here
        -- You can add your custom logic for single tap actions with one finger
        -- For example, pause or play the video on a single tap
        if isPlaying then
            videoView.pause()
            playPauseButton.setText("Play")
        else
            videoView.start()
            playPauseButton.setText("Pause")
        end
        isPlaying = not isPlaying
    end,
onDoubleTap = function(e)
        -- Handle double tap here
        -- This function is called when a double tap with one finger is detected
        -- You can add your custom logic for double tap actions
        -- For example, toggle fullscreen mode or perform other actions
        isTwoFingerTap = false
        -- Add your double-tap logic here
    end,
onDoubleTapEvent = function(e)
        if e.getActionMasked() == MotionEvent.ACTION_UP then
            isTwoFingerTap = true
        end
    end,
onFling = function(e1, e2, velocityX, velocityY)
        if not isTwoFingerTap then
            local diffY = e2.getY() - e1.getY()
            local diffX = e2.getX() - e1.getX()
            
            if math.abs(diffY) > 100 and math.abs(velocityY) > 100 then
                if diffY > 0 then
                    -- Swipe down (previous video)
                    prevOrLoop()
                else
                    -- Swipe up (next video)
                    nextOrLoop()
                end
            elseif math.abs(diffX) > 100 and math.abs(velocityX) > 100 then
                if diffX > 0 then
                    -- Swipe right (forward video)
                    forwardVideo()
                else
                    -- Swipe left (rewind video)
                    rewindVideo()
                end
            end
        end
        return true
    end
})
-- Set the touch listener for your videoView to the GestureDetector
videoView.setOnTouchListener(View.OnTouchListener {
    onTouch = function(view, event)
        gestureDetector.onTouchEvent(event)
        return true
    end

})-- Calculate the desired width and height percentages for the buttons
local buttonWidthPercentage = 10 
-- Adjust this percentage as needed
local buttonHeightPercentage = 10 
-- Adjust this percentage as needed

-- Calculate the screen width and height
local screenWidth = activity.getResources().getDisplayMetrics().widthPixels
local screenHeight = activity.getResources().getDisplayMetrics().heightPixels

-- Calculate the button width and height based on percentages
local buttonWidth = (buttonWidthPercentage / 100) * screenWidth
local buttonHeight = (buttonHeightPercentage / 100) * screenHeight

-- Set the calculated width and height for the buttons
playPauseButton.setWidth(buttonWidth)
playPauseButton.setHeight(buttonHeight)

prevButton.setWidth(buttonWidth)
prevButton.setHeight(buttonHeight)

nextButton.setWidth(buttonWidth)
nextButton.setHeight(buttonHeight)

deleteButton.setWidth(buttonWidth)
deleteButton.setHeight(buttonHeight)

shareButton.setWidth(buttonWidth)
shareButton.setHeight(buttonHeight)

showAllButton.setWidth(buttonWidth)
showAllButton.setHeight(buttonHeight)

renameButton.setWidth(buttonWidth)
renameButton.setHeight(buttonHeight)

finishTaskButton.setWidth(buttonWidth)
finishTaskButton.setHeight(buttonHeight)

-- Create a layout to hold the buttons, seek bar, and track info
local controlLayout = LinearLayout(activity)
controlLayout.setOrientation(LinearLayout.HORIZONTAL)controlLayout.setGravity(Gravity.CENTER)  

local buttonBackgroundColor = 0xFFE91E63 -- Pink color, change to your preferred color
local buttonTextColor = 0xFFFFFFFF -- White color
playPauseButton.setBackgroundColor(buttonBackgroundColor)
prevButton.setBackgroundColor(buttonBackgroundColor)
nextButton.setBackgroundColor(buttonBackgroundColor)
shareButton.setBackgroundColor(buttonBackgroundColor)
deleteButton.setBackgroundColor(buttonBackgroundColor)
showAllButton.setBackgroundColor(buttonBackgroundColor)
playPauseButton.setTextColor(buttonTextColor)
prevButton.setTextColor(buttonTextColor)
nextButton.setTextColor(buttonTextColor)
shareButton.setTextColor(buttonTextColor)
deleteButton.setTextColor(buttonTextColor)
showAllButton.setTextColor(buttonTextColor)
local buttonTextSize = 16 -- Adjust text size as needed
local buttonPadding = 16 -- Adjust padding as needed
playPauseButton.setTextSize(buttonTextSize)
prevButton.setTextSize(buttonTextSize)
nextButton.setTextSize(buttonTextSize)
shareButton.setTextSize(buttonTextSize)
deleteButton.setTextSize(buttonTextSize)
showAllButton.setTextSize(buttonTextSize)

-- Calculate the percentage of vertical space you want for the controlLayout
local controlLayoutPercentage = 80 
 -- Adjust this percentage as needed

-- Calculate the layout weight for the controlLayout
local controlLayoutWeight = controlLayoutPercentage / 100.0

-- Create layout parameters for the controlLayout with the calculated weight
local controlLayoutParams = LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, 0, controlLayoutWeight)
controlLayout.setLayoutParams(controlLayoutParams)
-- Calculate the desired width and height percentages for mainLayout
local mainLayoutWidthPercentage = 80  -- Adjust this percentage as needed
local mainLayoutHeightPercentage = 80  -- Adjust this percentage as needed

controlLayout.addView(playPauseButton)
controlLayout.addView(prevButton)
controlLayout.addView(nextButton)
controlLayout.addView(deleteButton) 
controlLayout.addView(shareButton)
controlLayout.addView(renameButton)
controlLayout.addView(finishTaskButton)

-- Added the Delete Button

-- Create a layout to hold everything
local mainLayout = LinearLayout(activity)
mainLayout.setOrientation(LinearLayout.VERTICAL)
mainLayout.setBackgroundColor(0xFF303F9F) -- 

-- Calculate the desired width and height percentages for mainLayout
local mainLayoutWidthPercentage = 95 
 -- Adjust this percentage as needed
local mainLayoutHeightPercentage = 95 
 -- Adjust this percentage as needed

-- Calculate the screen width and height
local screenWidth = activity.getResources().getDisplayMetrics().widthPixels
local screenHeight = activity.getResources().getDisplayMetrics().heightPixels

-- Calculate the width and height for mainLayout based on percentages
local mainLayoutWidth = (mainLayoutWidthPercentage / 100) * screenWidth
local mainLayoutHeight = (mainLayoutHeightPercentage / 100) * screenHeight

-- Create layout parameters for mainLayout with the calculated dimensions
local mainLayoutParams = LinearLayout.LayoutParams(mainLayoutWidth, mainLayoutHeight)

-- Set the layout parameters for mainLayout
mainLayout.setLayoutParams(mainLayoutParams)

mainLayout.addView(videoView)
mainLayout.addView(controlLayout)
mainLayout.addView(seekBar)
mainLayout.addView(trackInfo)
mainLayout.addView(showAllButton) 
--mainLayout.addView(fileListView)

 -- Added "Show All Files" button

-- Set the touch listener for the mainLayout to the GestureDetector
mainLayout.setOnTouchListener(View.OnTouchListener {
    onTouch = function(view, event)
        gestureDetector.onTouchEvent(event)
        return true
    end
})

-- Set the content view to the mainLayout
--activity.setContentView(mainLayout)

-- Call the function to explore the folder and check if it's empty before showing the dialog
local folder = File(folderPath)
exploreFolder(folder)

-- Initialize the current index
local currentIndex = 0

-- ... (rest of your code)

-- Call the function to explore the folder and add videos to the playlist
local folder = File(folderPath)
exploreFolder(folder)

-- Check if the playlist is empty and show a Toast message if it is
if playlist.isEmpty() then
    local toast = Toast.makeText(activity, "The folder is empty.", Toast.LENGTH_SHORT)
    toast.show()
else
    -- Call the function to play the first video automatically
    playFirstVideo()
    
    -- Set the layout for the dialog
activity.setContentView(mainLayout)
end